//+------------------------------------------------------------------+
//|                                            GradientT1_SinCos.mq4 |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#include <Canvas\Canvas.mqh>
input int tsx=300;//test size x 
input int tsy=300;//test size y 
input double angie=0;//"gradient" angle
CCanvas Drawer;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- create timer
   //EventSetTimer(60);
   //degrees to radians 
   double radian=0.0174532925;
   double ang_rads=radian*angie;
   //statics 
   double cos_a=MathCos(ang_rads);
   double sin_a=MathSin(ang_rads);
   double min_value;
   double max_value;
   double dv_x,dv_y,dv;
   //loop into pseudo canvas
     for(int px=0;px<=tsx;px++)
     {
     dv_x=px;
     dv_x=dv_x*sin_a;
     for(int py=0;py<=tsy;py++)
        {
        dv_y=py;
        dv_y=dv_y*cos_a;
        dv=dv_x+dv_y;
          if(px==0&&py==0)
          {
          min_value=dv;
          max_value=dv;
          }
          if(dv>max_value) max_value=dv;
          if(dv<min_value) min_value=dv;
        }
     }
   //loop into pseudo canvas ends here 
   //step
   double v_step=max_value-min_value;
   v_step=v_step/255;
   
   //create canvas 
   uint ec=ColorToARGB(clrBlack,255);
   ObjectDelete(0,"Drawer");
   Drawer.CreateBitmapLabel(0,0,"Drawer",0,0,tsx,tsy,COLOR_FORMAT_ARGB_NORMALIZE);
   Drawer.Erase(ec);
   Drawer.Update(true);           
   //create canvas ends here 
   //Loop and draw
   for(int x=0;x<=tsx;x++)
   {
     dv_x=x;
     dv_x=dv_x*sin_a;   
   for(int y=0;y<=tsy;y++)
     {
        dv_y=y;
        dv_y=dv_y*cos_a;
        dv=dv_x+dv_y;     
        dv=dv-min_value;
        dv=dv/v_step;
        int colo=dv;
        uint co=ARGBToUintWithStrings(255,colo,colo,colo);
        Drawer.PixelSet(x,y,co);
     }
   }
   //Loop and draw ends here 
   Drawer.Update(true);
   Print("DONE");
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//--- destroy timer
   //EventKillTimer();
      
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
  {
//---
   
  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//---
   
  }
//+------------------------------------------------------------------+
 uint ARGBToUintWithStrings(int alpha,int red,int green,int blue)
 {
 string c_c_h=IntegerToString(red)+","+IntegerToString(green)+","+IntegerToString(blue);
 color co_co=StringToColor(c_c_h);      
 uint reto=ColorToARGB(co_co,alpha);
 return(reto);
 }